#include "CAPCContext.h"

CAPCContext::CAPCContext(PVOID pOrigAPCContext, 
                         PIO_APC_ROUTINE pOrigAPCRoutine,
                         PVOID pUserBuffer,
                         IKBExternalObserver *pObserver,
                         PIRP pCurrentIRP):
    m_pOrigAPCContext(pOrigAPCContext),
    m_pOrigAPCRoutine(pOrigAPCRoutine),
    m_pUserBuffer(pUserBuffer),
    m_pObserver(pObserver),
    m_pCurrentIRP(pCurrentIRP)
{
}

PVOID CAPCContext::GetOriginalAPCContext(void){
    return(m_pOrigAPCContext);
}

PIO_APC_ROUTINE CAPCContext::GetOriginalAPCRoutine(void){
    return(m_pOrigAPCRoutine);
}

PVOID CAPCContext::GetUserBuffer(void){
    return(m_pUserBuffer);
}

IKBExternalObserver* CAPCContext::GetObserver(void){
    return(m_pObserver);
}

PIRP CAPCContext::GetCurrentIRP(void){
    return(m_pCurrentIRP);
}
