#ifndef __C_APC_CONTEXT_H__
#define __C_APC_CONTEXT_H__

extern "C"{
    #include <ntifs.h>
}

#include "IExternalObserver.h"

class CAPCContext{
    public:
        CAPCContext(PVOID pOrigAPCContext, 
                    PIO_APC_ROUTINE pOrigAPCRoutine,
                    PVOID pUserBuffer,
                    IKBExternalObserver *pObserver,
                    PIRP pCurrentIRP);
        
        PVOID GetOriginalAPCContext(void);
        PIO_APC_ROUTINE GetOriginalAPCRoutine(void);
        PVOID GetUserBuffer(void);
        IKBExternalObserver* GetObserver(void);
        PIRP GetCurrentIRP(void);

    private:
        PVOID m_pOrigAPCContext;
        PIO_APC_ROUTINE m_pOrigAPCRoutine;
        PVOID m_pUserBuffer;
        IKBExternalObserver *m_pObserver;
        PIRP m_pCurrentIRP;
};

#endif