#ifndef __I_IRP_PROCESSOR_H__
#define __I_IRP_PROCESSOR_H__

extern "C"{
	#include <ntifs.h>
}

#include "IExternalObserver.h"

struct IIRPProcessor{

	//List of pending packets (needs for force complete and pending counter)
	virtual void AddPendingPacket(PIRP pIRP) = 0;
	virtual void RemovePendingPacket(PIRP pIRP) = 0;

	//Main external observer for events
	virtual IKBExternalObserver* GetDeviceObserver(void) = 0;
};

#endif