#ifndef __KBDCLASS_DEFS_H__
#define __KBDCLASS_DEFS_H__

extern "C"{
	#include <ntddkbd.h>
	#include <wmilib.h>
}

//Copy from DDK kbdclass.sys sample
typedef struct _KBDCLASS_DEVICE_EXTENSION{
	PDEVICE_OBJECT  Self;
	PDEVICE_OBJECT  TrueClassDevice;
	PDEVICE_OBJECT  TopPort;
	PDEVICE_OBJECT  PDO;
	IO_REMOVE_LOCK  RemoveLock;
	BOOLEAN         PnP;
	BOOLEAN         Started;
	BOOLEAN         AllowDisable;
	KSPIN_LOCK WaitWakeSpinLock;
	ULONG TrustedSubsystemCount;
	ULONG InputCount;
	UNICODE_STRING  SymbolicLinkName;
	PKEYBOARD_INPUT_DATA InputData;
	PKEYBOARD_INPUT_DATA DataIn;
	PKEYBOARD_INPUT_DATA DataOut;
	KEYBOARD_ATTRIBUTES  KeyboardAttributes;
	KEYBOARD_INDICATOR_PARAMETERS   IndicatorParameters;
	KSPIN_LOCK SpinLock;
	LIST_ENTRY ReadQueue;
	ULONG SequenceNumber;
	DEVICE_POWER_STATE DeviceState;
	SYSTEM_POWER_STATE SystemState;
	ULONG UnitId;
	WMILIB_CONTEXT WmiLibInfo;
	DEVICE_POWER_STATE SystemToDeviceState[PowerSystemHibernate];
	DEVICE_POWER_STATE MinDeviceWakeState;
	SYSTEM_POWER_STATE MinSystemWakeState;
	PIRP WaitWakeIrp;
	PIRP ExtraWaitWakeIrp;
	PVOID TargetNotifyHandle;
	LIST_ENTRY Link;
	PFILE_OBJECT File;
	BOOLEAN Enabled;
	BOOLEAN OkayToLogOverflow;
	BOOLEAN WaitWakeEnabled;
	BOOLEAN SurpriseRemoved;
} KBDCLASS_DEVICE_EXTENSION, *PKBDCLASS_DEVICE_EXTENSION;


#endif