#ifndef _INC_WCHAR
#define _INC_WCHAR

__inline int __CRTDECL wmemcmp(const wchar_t *_S1, const wchar_t *_S2, size_t _N)
{
    for (; 0 < _N; ++_S1, ++_S2, --_N)
        if (*_S1 != *_S2)
            return (*_S1 < *_S2 ? -1 : +1);
    return (0); 
}

__inline wchar_t * __CRTDECL wmemset(wchar_t *_S, wchar_t _C, size_t _N)
{
    wchar_t *_Su = _S;
    for (; 0 < _N; ++_Su, --_N)
    {
        *_Su = _C;
    }
    return (_S);
}

#endif