#ifndef __I_EXTERNAL_OBSERVER_H__
#define __I_EXTERNAL_OBSERVER_H__

extern "C"{
	#include <ntifs.h>
}

typedef struct _KEY_STATE_DATA{
	unsigned short* pusScanCode;
	bool bPressed;
} _KEY_STATE_DATA, KEY_STATE_DATA;

struct IKBExternalObserver{
	virtual void OnProcessEvent(KEY_STATE_DATA& data) = 0;
};

struct IKBExternalObserverEx{
	virtual void OnProcessEvent(PDEVICE_OBJECT pTopPortDevice, KEY_STATE_DATA& data) = 0;
};

#endif