#ifndef __I_IRP_DISPATCHER_H__
#define __I_IRP_DISPATCHER_H__

#include "IIRPPRocessor.h"

struct IIRPDispatcher{
	typedef void(*PDISPATCHCALLBACK)(IIRPProcessor *pContext, PIRP pIRP);

	//IRP dispatchers
	virtual NTSTATUS DispatchPassThrough(PIRP pIRP) = 0;
	virtual NTSTATUS DispatchRead(PIRP pIRP, PDISPATCHCALLBACK pCallback) = 0;
	virtual NTSTATUS DispatchPower(PIRP pIRP) = 0;
};

#endif